Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/1801.html

1801. Number of Orders in the Backlog

Level

Medium

Description

You are given a 2D integer array orders, where each orders[i] = [price_i, amount_i, orderType_i] denotes that amount_i orders have been placed of type orderType_i at the price price_i. The orderTypei is:

  • 0 if it is a batch of buy orders, or
  • 1 if it is a batch of sell orders.

Note that orders[i] represents a batch of amount_i independent orders with the same price and order type. All orders represented by orders[i] will be placed before all orders represented by orders[i+1] for all valid i.

There is a backlog that consists of orders that have not been executed. The backlog is initially empty. When an order is placed, the following happens:

  • If the order is a buy order, you look at the sell order with the smallest price in the backlog. If that sell order’s price is smaller than or equal to the current buy order’s price, they will match and be executed, and that sell order will be removed from the backlog. Else, the buy order is added to the backlog.
  • Vice versa, if the order is a sell order, you look at the buy order with the largest price in the backlog. If that buy order’s price is larger than or equal to the current sell order’s price, they will match and be executed, and that buy order will be removed from the backlog. Else, the sell order is added to the backlog.

Return the total amount of orders in the backlog after placing all the orders from the input. Since this number can be large, return it modulo 10^9 + 7.

Example 1:

Image text

Input: orders = [[10,5,0],[15,2,1],[25,1,1],[30,4,0]]

Output: 6

Explanation: Here is what happens with the orders:

  • 5 orders of type buy with price 10 are placed. There are no sell orders, so the 5 orders are added to the backlog.
  • 2 orders of type sell with price 15 are placed. There are no buy orders with prices larger than or equal to 15, so the 2 orders are added to the backlog.
  • 1 order of type sell with price 25 is placed. There are no buy orders with prices larger than or equal to 25 in the backlog, so this order is added to the backlog.
  • 4 orders of type buy with price 30 are placed. The first 2 orders are matched with the 2 sell orders of the least price, which is 15 and these 2 sell orders are removed from the backlog. The 3rd order is matched with the sell order of the least price, which is 25 and this sell order is removed from the backlog. Then, there are no more sell orders in the backlog, so the 4th order is added to the backlog.

Finally, the backlog has 5 buy orders with price 10, and 1 buy order with price 30. So the total number of orders in the backlog is 6.

Example 2:

Image text

Input: orders = [[7,1000000000,1],[15,3,0],[5,999999995,0],[5,1,1]]

Output: 999999984

Explanation: Here is what happens with the orders:

  • 109 orders of type sell with price 7 are placed. There are no buy orders, so the 109 orders are added to the backlog.
  • 3 orders of type buy with price 15 are placed. They are matched with the 3 sell orders with the least price which is 7, and those 3 sell orders are removed from the backlog.
  • 999999995 orders of type buy with price 5 are placed. The least price of a sell order is 7, so the 999999995 orders are added to the backlog.
  • 1 order of type sell with price 5 is placed. It is matched with the buy order of the highest price, which is 5, and that buy order is removed from the backlog.

Finally, the backlog has (1000000000-3) sell orders with price 7, and (999999995-1) buy orders with price 5. So the total number of orders = 1999999991, which is equal to 999999984 % (109 + 7).

Constraints:

  • 1 <= orders.length <= 10^5
  • orders[i].length == 3
  • 1 <= price_i, amount_i <= 10^9
  • orderType_i is either 0 or 1.

Solution

Use two tree maps to store the buy orders and the sell orders. Each map’s key is the price and the value is the amount. Loop over orders. For each order, if it is a buy order, find the first entry in the sell map and update the entries accordingly. Otherwise, find the last entry in the buy map and update the entries accordingly. Finally, count the total number of remaining orders and return.

  • class Solution {
        public int getNumberOfBacklogOrders(int[][] orders) {
            final int MODULO = 1000000007;
            TreeMap<Integer, Integer> buyMap = new TreeMap<Integer, Integer>();
            TreeMap<Integer, Integer> sellMap = new TreeMap<Integer, Integer>();
            int length = orders.length;
            for (int i = 0; i < length; i++) {
                int[] order = orders[i];
                int price = order[0], amount = order[1], orderType = order[2];
                if (orderType == 0) {
                    while (amount > 0 && sellMap.size() > 0 && sellMap.firstKey() <= price) {
                        Integer key = sellMap.firstKey();
                        int sellAmount = sellMap.get(key);
                        if (sellAmount <= amount) {
                            amount -= sellAmount;
                            sellMap.remove(key);
                        } else {
                            sellMap.put(key, sellAmount - amount);
                            amount = 0;
                        }
                    }
                    if (amount > 0)
                        buyMap.put(price, buyMap.getOrDefault(price, 0) + amount);
                } else {
                    while (amount > 0 && buyMap.size() > 0 && buyMap.lastKey() >= price) {
                        Integer key = buyMap.lastKey();
                        int buyAmount = buyMap.get(key);
                        if (buyAmount <= amount) {
                            amount -= buyAmount;
                            buyMap.remove(key);
                        } else {
                            buyMap.put(key, buyAmount - amount);
                            amount = 0;
                        }
                    }
                    if (amount > 0)
                        sellMap.put(price, sellMap.getOrDefault(price, 0) + amount);
                }
            }
            int count = 0;
            for (Map.Entry<Integer, Integer> entry : buyMap.entrySet())
                count = (count + entry.getValue()) % MODULO;
            for (Map.Entry<Integer, Integer> entry : sellMap.entrySet())
                count = (count + entry.getValue()) % MODULO;
            return count;
        }
    }
    
    ############
    
    class Solution {
        public int getNumberOfBacklogOrders(int[][] orders) {
            PriorityQueue<int[]> buy = new PriorityQueue<>((a, b) -> b[0] - a[0]);
            PriorityQueue<int[]> sell = new PriorityQueue<>((a, b) -> a[0] - b[0]);
            for (var e : orders) {
                int p = e[0], a = e[1], t = e[2];
                if (t == 0) {
                    while (a > 0 && !sell.isEmpty() && sell.peek()[0] <= p) {
                        var q = sell.poll();
                        int x = q[0], y = q[1];
                        if (a >= y) {
                            a -= y;
                        } else {
                            sell.offer(new int[] {x, y - a});
                            a = 0;
                        }
                    }
                    if (a > 0) {
                        buy.offer(new int[] {p, a});
                    }
                } else {
                    while (a > 0 && !buy.isEmpty() && buy.peek()[0] >= p) {
                        var q = buy.poll();
                        int x = q[0], y = q[1];
                        if (a >= y) {
                            a -= y;
                        } else {
                            buy.offer(new int[] {x, y - a});
                            a = 0;
                        }
                    }
                    if (a > 0) {
                        sell.offer(new int[] {p, a});
                    }
                }
            }
            long ans = 0;
            final int mod = (int) 1e9 + 7;
            while (!buy.isEmpty()) {
                ans += buy.poll()[1];
            }
            while (!sell.isEmpty()) {
                ans += sell.poll()[1];
            }
            return (int) (ans % mod);
        }
    }
    
  • // OJ: https://leetcode.com/problems/number-of-orders-in-the-backlog/
    // Time: O(NlogN)
    // Space: O(N)
    class Solution {
    public:
        int getNumberOfBacklogOrders(vector<vector<int>>& A) {
            long mod = 1e9+7, ans = 0;
            map<int, long> buy, sell;
            for (auto &v : A) {
                long price = v[0], amount = v[1], type = v[2];
                if (type == 0) { // buy
                    while (sell.size() && amount) {
                        auto &[p, am] = *sell.begin();
                        if (p <= price) {
                            int d = min(am, amount);
                            am -= d;
                            amount -= d;
                            if (am == 0) sell.erase(p);
                        } else break;
                    }
                    if (amount) {
                        buy[price] += amount;
                    }
                } else {
                    while (buy.size() && amount) {
                        auto &[p, am] = *buy.rbegin();
                        if (p >= price) {
                            int d = min(am, amount);
                            am -= d;
                            amount -= d;
                            if (am == 0) buy.erase(p);
                        } else break;
                    }
                    if (amount) {
                        sell[price] += amount;
                    }
                }
            }
            for (auto &[p, a] : buy) ans = (ans + a) % mod;
            for (auto &[p, a] : sell) ans = (ans + a) % mod;
            return ans;
        }
    };
    
  • class Solution:
        def getNumberOfBacklogOrders(self, orders: List[List[int]]) -> int:
            buy, sell = [], []
            for p, a, t in orders:
                if t == 0:
                    while a and sell and sell[0][0] <= p:
                        x, y = heappop(sell)
                        if a >= y:
                            a -= y
                        else:
                            heappush(sell, (x, y - a))
                            a = 0
                    if a:
                        heappush(buy, (-p, a))
                else:
                    while a and buy and -buy[0][0] >= p:
                        x, y = heappop(buy)
                        if a >= y:
                            a -= y
                        else:
                            heappush(buy, (x, y - a))
                            a = 0
                    if a:
                        heappush(sell, (p, a))
            mod = 10**9 + 7
            return sum(v[1] for v in buy + sell) % mod
    
    ############
    
    # 1801. Number of Orders in the Backlog
    # https://leetcode.com/problems/number-of-orders-in-the-backlog/
    
    from heapq import heappop,heappush
    
    class Solution:
        def getNumberOfBacklogOrders(self, orders: List[List[int]]) -> int:
            M = 10 ** 9 + 7
            
            buy, sell = [], []
            
            for price,amt,ot in orders:
                if ot == 0:
                    heappush(buy, [-price, amt])
                else:
                    heappush(sell, [price, amt])
                
                while sell and buy and -buy[0][0] >= sell[0][0]:
                    to_deduct = min(buy[0][1], sell[0][1])
                    buy[0][1] -= to_deduct
                    sell[0][1] -= to_deduct
                    
                    if buy[0][1] == 0: heappop(buy)
                    if sell[0][1] == 0: heappop(sell)
            
            return sum(amt for price,amt in buy+sell) % M
    
    
  • func getNumberOfBacklogOrders(orders [][]int) (ans int) {
    	sell := hp{}
    	buy := hp{}
    	for _, e := range orders {
    		p, a, t := e[0], e[1], e[2]
    		if t == 0 {
    			for a > 0 && len(sell) > 0 && sell[0].p <= p {
    				q := heap.Pop(&sell).(pair)
    				x, y := q.p, q.a
    				if a >= y {
    					a -= y
    				} else {
    					heap.Push(&sell, pair{x, y - a})
    					a = 0
    				}
    			}
    			if a > 0 {
    				heap.Push(&buy, pair{-p, a})
    			}
    		} else {
    			for a > 0 && len(buy) > 0 && -buy[0].p >= p {
    				q := heap.Pop(&buy).(pair)
    				x, y := q.p, q.a
    				if a >= y {
    					a -= y
    				} else {
    					heap.Push(&buy, pair{x, y - a})
    					a = 0
    				}
    			}
    			if a > 0 {
    				heap.Push(&sell, pair{p, a})
    			}
    		}
    	}
    	const mod int = 1e9 + 7
    	for len(buy) > 0 {
    		ans += heap.Pop(&buy).(pair).a
    	}
    	for len(sell) > 0 {
    		ans += heap.Pop(&sell).(pair).a
    	}
    	return ans % mod
    }
    
    type pair struct{ p, a int }
    type hp []pair
    
    func (h hp) Len() int            { return len(h) }
    func (h hp) Less(i, j int) bool  { return h[i].p < h[j].p }
    func (h hp) Swap(i, j int)       { h[i], h[j] = h[j], h[i] }
    func (h *hp) Push(v interface{}) { *h = append(*h, v.(pair)) }
    func (h *hp) Pop() interface{}   { a := *h; v := a[len(a)-1]; *h = a[:len(a)-1]; return v }
    

All Problems

All Solutions